<template>

  <div class="stations" v-if="!selectedStation">
    <h3>Aquifères/contrat de captages</h3>

    <input class="filter" type="text"
      v-model="searchQuery" placeholder="Filtrer..." />

    <ul class="stations-list">
      <template v-for="(s,i) in filteredStations" :key="s.id">
        <h4 v-if="filteredStations[i].properties.aquifer !== filteredStations[i-1]?.properties.aquifer"
          class="my-2">
          {{ s.properties.aquifer }}
        </h4>
        <li>
          <span @click="selectStation(s)">
            <i class="fa fa-map-marker fa-fw"></i>
            {{ s.properties.name }}
          </span>
        </li>
      </template>
    </ul>
  </div>

  <div class="station" v-else>
    <div class="section-header">
      <a @click="selectStation(null)">
        <i class="fa fa-chevron-left fa-fw"></i> Retour
      </a>
      <h2 class="title">{{ selectedStation?.properties.name }}</h2>
    </div>
    <div class="section-wrapper">

      <div class="section">
        <h3 class='title' @click="toggleMode('info')">
          <i class="fa fa-fw" :class="activeModeClass('info')"></i>
          Fiche technique du captage
        </h3>
        <div class='content properties' v-if="mode === 'info'">

          <table class="tinline">
            <tbody>
              <tr v-if="selectedStation.properties.service">
                <td class="name">État: </td>
                <td class="value">en service</td>
              </tr>
              <tr v-if="selectedStation.properties.elevation">
                <td class="name">Altitude: </td>
                <td class="value">{{ selectedStation.properties.elevation }} m</td>
              </tr>
              <tr v-if="selectedStation.properties.municipality">
                <td class="name">Commune: </td>
                <td class="value">{{ selectedStation.properties.municipality }}</td>
              </tr>
              <tr>
                <td class="name">Profondeur: </td>
                <td class="value">{{ formatDepth(selectedStation.properties.depth) }} m</td>
              </tr>
              <tr>
                <td class="name">Prof. des crépines: </td>
                <td class="value">{{ selectedStation.properties.strainerDepth }} m</td>
              </tr>
              <tr>
                <td class="name">Aquifère: </td>
                <td class="value">{{ selectedStation.properties.aquifer }}</td>
              </tr>
              <tr>
                <td class="name">Type d'aquifère: </td>
                <td class="value">{{ selectedStation.properties.aquiferKind }}</td>
              </tr>
              <tr>
                <td class="name">Type: </td>
                <td class="value">{{ selectedStation.properties.kind }}</td>
              </tr>
              <tr>
                <td class="name">Zone de prévention: </td>
                <td class="value">{{ selectedStation.properties.preventionZone }}</td>
              </tr>
            </tbody>
          </table>

        </div>
      </div>

      <div class="section">
        <h3 class='title' @click="toggleMode('layers')">
          <i class="fa fa-fw" :class="activeModeClass('layers')"></i>
          Évaluation du risque
        </h3>
        <div class='content layers' v-if="mode === 'layers'">

          <button type="button" class="btn btn-link">
            <i class="fa fa-fw fa-info-circle"
              title="Plus d'informations sur la zone"
              @click="createStationLandUseInfoModal">
            </i>
          </button>

          <h5>Facteurs de vulnérabilité</h5>
          <LayerTree category='drastic'/>

          <h5>Facteurs de pression</h5>
          <LayerTree category='pressure'/>

          <h5>Autres données utiles</h5>
          <LayerTree category='info'/>

        </div>
      </div>

      <div class="section">
        <h3 class='title' @click="toggleMode('quality')">
          <i class="fa fa-fw" :class="activeModeClass('quality')"></i>
          Paramètres de qualité
        </h3>
        <div class='content parameters' v-if="mode === 'quality'">

          <button type="button" class="btn btn-link">
            <i class="fa fa-fw fa-info-circle"
              title="Méthodes utilisées"
              @click="createMethodInfoModal">
            </i>
          </button>

          <div class="form-selector">
            <label for="parameters">choix du paramètre:</label>
            <div class="select-wrapper">
              <select class="" name="parameters" id="parameters" @change="onParameterChange($event)" :value=selectedParameter.id>
                <option v-for="p in store.getters.getDiagnosticParameters" :value="p.id" :key="p.id">{{ p.name }}</option>
              </select>
            </div>
          </div>

          <div class="form-check" v-if="selectedParameter.threshold" >
            <input class="form-check-input"
              type="checkbox"
              id="normales"
              name="normales"
              :checked="store.state.showNorm"
              @change="onShowNormChange($event)">
            <label class="form-check-label" for="normales">Afficher la norme ({{ store.getters.getNormLabel }})</label><br>
          </div>

          <div class="form-check">
            <input class="form-check-input"
              type="checkbox"
              id="trends"
              name="trends"
              :checked=store.state.trendCheckbox
              @change="onTrendCheckboxChange($event)">
            <label class="form-check-label" for="trends">Afficher des droites de tendance</label><br>
          </div>

          <table class="tinline my-4">
            <thead>
              <tr>
                <th scope="col">{{ selectedParameter.name }}</th>
                <th scope="col"></th>
              </tr>
            </thead>
            <tbody>
            <tr>
              <td class="name">Valeur moyenne:
                <small class="">(au cours de la dernière année - {{ store.getters.getDataLastYear }})</small>
              </td>
              <td class="value">{{ store.getters.getLastYearAverageMainStation }} {{ store.getters.getParameterUnit }}</td>
            </tr>
            <tr class="trends" v-if="stationParameterTrend.length > 0">
              <td class="name" colspan="2">Tendance:
                <span class="float-end">
                  <span v-for="(t, i) in stationParameterTrend" :key="i">
                    <span v-if="i > 0">&nbsp;{{ store.getters.getTrendYearMonth(new Date(t.date)) }}</span>
                    <i :style="{
                      'transform': store.getters.getTrendAngle(t.slope, t.significance),
                      'color': store.getters.getTrendColor(t.slope, t.significance)
                    }" class="fa fa-long-arrow-up"></i>
                  </span>
                </span>
              </td>
            </tr>
            </tbody>
          </table>

          <div class="form-selector" v-if="filteredRecords.length">
            <label for="stations">Comparaison avec une autre station</label>
            <div class="select-wrapper">
              <select class="" name="stations" id="stations" @change="onExtraStationChange($event)">
                <option selected value="">Choisissez une station</option>
                <option v-for="s in store.getters.getListExtraStations" :value="s.id" :key="s.id">{{ s.properties.name }}</option>
              </select>
            </div>
          </div>

          <div class="form-selector">
            <label for="timeInterval">Fenêtre temporelle</label>
            <Slider class="slider slider-blue"
              id="timeInterval"
              v-model="timeInterval"
              @change="selectTimeInterval"
              :min="sliderMin"
              :max="sliderMax" />
          </div>

        </div>
      </div>
    </div>
  </div>

</template>

<script lang="ts">
import {fromLonLat} from 'ol/proj';
import { defineComponent, ref, computed, watch } from 'vue';
import { Station } from '@/api';
import Slider from '@vueform/slider';
import { useStore } from '@/store';
import { SidebarMode } from '@/utils/_types';
import LayerTree from './LayerTree.vue';
import { removeSidebarLayers } from './map';

export default defineComponent({
  name: 'Sidebar',
  components: { Slider, LayerTree },
  setup: () => {

    /**
     * STORE
     */
    const store = useStore();

    /**
     * STATE
     */
    let sliderMin = 1960;
    let sliderMax = new Date().getFullYear();

    const searchQuery = ref<String>("");

    /**
     * WATCH
     */
    watch(() => store.state.selectedStationId, (newStation) => {
      if (newStation !== null) {
        const selectedStation = store.state.stations?.filter((station) => station.id === newStation)
        changeMapView(selectedStation[0]);
      }
    })

    /**
     * METHODS
     */

        // toggle different views
    const isModeActive = (m: SidebarMode) => store.state.sidebarMode === m;

    const activeModeClass = (m: SidebarMode) =>
        isModeActive(m) ? 'fa-caret-down' : 'fa-caret-right';

    const toggleMode = (m: SidebarMode) => {
      if (isModeActive(m)) {
        store.commit('setSidebarMode', null);
      } else {
        if (m === 'quality') {
          store.commit('switchContent', 'chart')
        } else {
          store.commit('switchContent', 'map')
        }
        store.commit('setSidebarMode', m)
      }
    }

    const selectStation = (s: Station | null) => {
      if (s === null) {
        changeMapView(s);
        store.commit('setSidebarMode', 'info');
        store.commit('setSelectedStationId', null)
        // reset store parameters
        store.dispatch('resetStore');
      } else {
        store.commit('setSelectedStationId', s.id)
      }
    };

    const changeMapView = (s: Station | null) => {
      const view = store.state.map.getView();
      const zoom = view?.getZoom();
      if (s) {
        if (undefined !== zoom && zoom < 15) {
          view?.setZoom(15);
          view?.setCenter(fromLonLat(s.geometry.coordinates, 'EPSG:3857'));
        }
        store.dispatch('getRecords');
        if (store.state.sidebarMode === 'quality') {
          store.commit('switchContent', 'chart');
          // filter the records of the selected station with the defaults in the store.
          store.dispatch('setFilteredRecordsMainStation');
        }
      }

      if (s === null) {
        view?.setZoom(9);
        view?.setCenter([485016.44, 6550857.95])
        if (store.state.content === 'chart') {
          store.commit('switchContent', 'map');
        }
        removeSidebarLayers(store.state.map);
      }
    }

    const filteredStations = computed(() => {
      const stationsList = store.state.stations.filter((station) => {
        return (
            station.properties.name
                .toLowerCase()
                .indexOf(searchQuery.value.toLowerCase()) != -1
        );
      });

      return stationsList.sort((a, b) => {
        if (a.properties.aquifer < b.properties.aquifer) {
          return -1;
        }
        if (a.properties.aquifer > b.properties.aquifer) {
          return 1;
        }
        return 0;
      })
    });

    //change graph view
    const selectTimeInterval = (interval) => {
      store.commit('setTimeInterval', interval)
      store.dispatch('setFilteredRecordsMainStation');
      if (store.state.extraStationId) {
        store.dispatch('setFilteredRecordsExtraStation');
      }
    }
    const onParameterChange = (event) => {
      store.commit('setSelectedParameter', parseInt(event.target.value));
      store.commit('setTimeInterval', []);
      store.commit('setStationParameterTrends', []);
      store.commit('setExtraStationParameterTrends', []);
      store.commit('setTrendCheckbox', false);
      store.dispatch('setFilteredRecordsMainStation');
      if (store.state.extraStationId) {
        store.dispatch('setFilteredRecordsExtraStation');
      }
      if (store.state.trendCheckbox) {
        store.dispatch('getTrends');
      }
      store.dispatch('getAllStationsRecords');
      store.dispatch('getSmoothData');
    }
    const onExtraStationChange = (event) => {
      if (event.target.value) {
        store.commit('setExtraSelectedStation', parseInt(event.target.value));
        store.dispatch('getExtraRecords');
        if (store.state.trendCheckbox) {
          store.dispatch('getTrends');
        }
        // filter the fetched records based on set parameter and time interval.
        store.dispatch('setFilteredRecordsExtraStation');
      } else {
        store.commit('setExtraSelectedStation', null);
        store.commit('setFilteredRecordsExtraStation', []);
      }
    }

    const onTrendCheckboxChange = () => {
      if (!store.state.trendCheckbox) {
        store.dispatch('getTrends');
      } else {
        store.commit('setStationParameterTrends', []);
        store.commit('setExtraStationParameterTrends', []);
      }
      store.commit('setTrendCheckbox', !store.state.trendCheckbox);
    }

    const onShowNormChange = () => {
      store.commit('setShowNorm', !store.state.showNorm);
    }

    const formatDepth = (depth: number): string => Number(depth).toFixed(2);

    const createMethodInfoModal = () =>
      store.commit('setModalState', {
        isOpen: !store.state.modalState.isOpen,
        type: 'graph-methods',
        title: 'Info sur les méthodes utilisées',
        content: ''
      });

    const createStationLandUseInfoModal = () => {
      let station = store.state.stations.find(
        (station: Station) => station.id === store.state.selectedStationId
      );
      if (station) {
        store.commit('setModalState', {
          isOpen: !store.state.modalState.isOpen,
          type: 'station-landuse',
          title: `Info sur la zone du captage (${station.properties.name})`,
          content: ''
        });
      }
    };


    return {
      store,
      searchQuery,
      filteredStations,
      sliderMin,
      sliderMax,
      isModeActive,
      activeModeClass,
      toggleMode,
      changeMapView,
      selectStation,
      selectTimeInterval,
      onParameterChange,
      onExtraStationChange,
      onTrendCheckboxChange,
      formatDepth,
      onShowNormChange,
      createMethodInfoModal,
      createStationLandUseInfoModal,
      mode: computed(() => store.state.sidebarMode),
      filteredRecords: computed(() => store.state.filteredRecords),
      timeInterval: computed(() => store.state.timeInterval),
      selectedStation: computed(() => store.state.stations.find((station) => station.id === store.state.selectedStationId)),
      selectedParameter: computed(() => store.state.parameters.find((p) => p.id === store.state.selectedParameter)),
      stationParameterTrend: computed(() => store.state.stationParameterTrend),
      mapLayers: computed(() => store.state.mapLayers),
    };
  },
})

</script>

<style src="@vueform/slider/themes/default.css" lang="scss"></style>

<style lang="scss" scoped>
  @import '../assets/_colors';
</style>
